# Import a standard function, and get the HTML request and response objects.
from Products.PythonScripts.standard import html_quote
request = container.REQUEST
response =  request.response

portal = context.getPortalObject()
portal_types = portal.portal_types

# if request.get('field_prefix', None):
#   field_prefix = 'your_'

fields_ = [field_1, field_2, field_3, field_4, field_5, 
            field_6, field_7, field_8, field_9, field_10]
field_types_ = [field_1_type, field_2_type, field_3_type, field_4_type, field_5_type,
                field_6_type, field_7_type, field_8_type, field_9_type, field_10_type]
#visibility_ = [kw['field_1_visibility'], kw['field_2_visibility'], kw['field_3_visibility'], kw['field_4_visibility'], kw['field_5_visibility'], 
#              kw['field_6_visibility'], kw['field_7_visibility'], kw['field_8_visibility'], kw['field_9_visibility'], kw['field_10_visibility']]

visibility_ = [field_1_visibility, field_2_visibility, field_3_visibility, field_4_visibility, field_5_visibility, 
              field_6_visibility, field_7_visibility, field_8_visibility, field_9_visibility, field_10_visibility]
              
ele_types = {'integer':'int', 'string':'string', 'float':'float', 'date':'date'}
field_names_ = {'integer':'my_integer_field', 'string':'my_string_field', 'float': 'my_float_field', 'date': 'my_date_time_field'}
                
property_sheets = portal.portal_property_sheets
  
# Create new property sheet with fields
failed_message = ""
failed = None
if failed or property_sheet_name in property_sheets:
  failed_message += "Property+sheet+name+already+taken.  "
  failed = 1
else:
  module_new_property_sheet = property_sheets.newContent(id = property_sheet_name)
  
  for i, field_name in enumerate(fields_):
    if field_name == "None":
      break;
    module_new_property_sheet.newContent(
          portal_type='Standard Property',
          reference=field_name,
          elementary_type=ele_types[field_types_[i]])

#create new portal type
if failed or descriptor_id in portal_types:
  failed_message += "Property+type+name+already+taken\n"
  failed = 1
else:
  module_portal_type_value = portal_types.newContent(id=descriptor_id,
                                                      title = data_type_name,
                                                      portal_type='Base Type',
                                                      type_class='Item',
                                                      type_property_Sheet=property_sheet_name)
  
  #adding a view
  module_portal_type_value.setTranslationDomain('title', 'erp5_ui')
  module_portal_type_value.setTranslationDomain('short_title', 'erp5_ui')
  
  module_list_form_id = ('%s_view%s' % ("DataDescriptor",
                          data_type_name)).replace(' ', '')
  
  module_portal_type_value.newContent(portal_type='Action Information',
    reference="view",
    title="View",
    action="string:${object_url}/%s" % module_list_form_id,
    action_type="object_list")
  
  # Create the skin folder if does not exist yet
  portal_skins_folder_name = portal_skins_folder
  portal_skins = portal.portal_skins
  if not portal_skins_folder_name in portal.portal_skins.objectIds():
    portal_skins.manage_addFolder(portal_skins_folder_name)

#create form in the skin folder
  skin_folder = portal.portal_skins[portal_skins_folder_name]
  factory = skin_folder.manage_addProduct['ERP5Form']
  factory.addERP5Form(module_list_form_id, title=data_type_name)
  form = skin_folder[module_list_form_id]
  default_groups = ['bottom', 'hidden']
  for group in default_groups:
    form.add_group(group)
    
  form.manage_settings(
      dict(field_title=form.title,
          field_name=form.name,
          field_description=form.description,
          field_action='Base_edit',
          field_update_action=form.update_action,
          field_update_action_title=form.update_action_title,
          field_enctype=form.enctype,
          field_encoding=form.encoding,
          field_stored_encoding=form.stored_encoding,
          field_unicode_mode=form.unicode_mode,
          field_method=form.method,
          field_row_length=str(form.row_length),
          field_pt='form_view',
          field_edit_order=[]))
  
  #listbox folder
  listbox_folder = portal_skins['woelfel_viblab_meda']
  view = listbox_folder['DataDescriptorModule_viewDataDescriptorList']
  v_listbox = view['listbox']
  
  for i, field_name in enumerate(fields_):
    if field_name == "None":
      break;
    new_field = form.manage_addField(
      id='my_' + field_name.lower(),
      fieldname= 'ProxyField',
      title='')
    form['my_'+field_name.lower()].manage_edit_xmlrpc(
    dict(form_id='Base_viewFieldLibrary',
        field_id=field_names_[field_types_[i]]))
    form['my_'+field_name.lower()].manage_edit_surcharged_xmlrpc(dict(title=fields_[i]))
    
    new_entry = (field_name.lower(),field_name)
    if visibility_[i] == 'column':
      column_list = v_listbox.get_value('columns')
    elif visibility_[i] == 'm_column':
      column_list = v_listbox.get_value('all_columns')
    else:
      continue
    
    if new_entry not in column_list:
      column_list.append(new_entry)
  
  data_descriptor_module=portal_types["Data Descriptor Module"]
  data_descriptor_module.setDefaultTypeAllowedContentType(data_type_name)

# redirect to page saying created
if failed:
  redirect_url = '%s/%s?%s' % ( context.absolute_url()
                              , form_id
                              , 'portal_status_message=' + failed_message
                              )
else:
  redirect_url = '%s/%s?%s' % ( context.absolute_url()
                          , form_id
                          , 'portal_status_message=Data+Descriptor+Created.'
                          )


request[ 'RESPONSE' ].redirect( redirect_url )


# portal_skins=portal.portal_skins
# listbox_folder = portal_skins['woelfel_viblab_meda']
# view = listbox_folder['DataDescriptorModule_viewDataDescriptorList']
# v_listbox = view['listbox']
# v_listbox.manage_edit_xmlrpc(dict(title='test title'))

# for i, field_name in enumerate(fields_):
#   if field_name == "None":
#     break;
#   new_entry = (field_name.lower(),field_name)
#   if visibility_[i] == 'column':
#     column_list = v_listbox.get_value('columns')
#   elif visibility_[i] == 'm_column':
#     column_list = v_listbox.get_value('all_columns')
#   else:
#     break;
  
#   if new_entry not in column_list:
#     print visibility_[i]
#     column_list.append(new_entry)
#   else:
#     print 'error'

# print 'success'
# print column_list


# return printed
